#pragma once

#include "typeDefinitions.h"
#include "iprinter.h"

#include <VmbCPP/Interface.h>

namespace VmbCPP {
	class VmbSystem;
	class CamObserver;
}
using VmbCPP::VmbSystem;
using VmbCPP::CamObserver;

class Core : public IPrinter
{

Q_OBJECT

public:
	Core();
	~Core();

public slots:
	void listCams();
	void detectCams();
	void onCameraChanged(CameraPtr,UpdateTriggerType); //called by CamObserver which is notified by Vimba SDK
	void openCam();
	void closeCam();
	void loadSettings();
	void saveSettings();
	CamPtr cam(const unsigned long &idx=-1);
	void startRecording();
	void stopRecording();
	void showRecordingStats();
	void showInfo();
	void setDuration1(seconds);
	void setDurationAll(seconds);
	// XXX add new func

private slots:
	void init();

private:

	VmbSystem& _sys;
	CamPtrVector _cameras;
	CamObserver* _camObserver;

};
