#pragma once

#include "typeDefinitions.h"

#include <QRunnable>
#include <VmbCPP/SharedPointerDefines.h>

class FrameProcessor : public QObject, public QRunnable
{
	Q_OBJECT

public:
	explicit FrameProcessor( CamPtr cam );
	~FrameProcessor();

	void run() override;
	void setFrame(const FramePtr);

signals:
	void frameProcessed(FramePtr);


private:
	CamPtr _cam;
	FramePtr _pframe;
	const QString _pixelFormatStr;
	const std::vector<int> _params;

	VmbUint32_t _width;
	VmbUint32_t _height;
	VmbUint64_t _timestamp;
	VmbPixelFormatType _pixelFormat;
};

