#pragma once

#include "VmbC/VmbCommonTypes.h"
#include "typeDefinitions.h"

#include <QStringList>

class QTimer;

// common functionality "interface" for printing, error handling and connecting messages to CMD
class IPrinter : public QObject
{
	Q_OBJECT

signals:
	void info(const QString &);
	void info(const QStringList&);
	void warning(const QString&);
	void error(const int&);
	void error(const QString&,const int& errCode=0);

public:
	explicit IPrinter(QObject *parent = nullptr);
	IPrinter(const IPrinter&) = delete; //cuz of err with non-trivial copy ctor which cant be implicitly created... if cp'ing is needed implement it!
	virtual ~IPrinter();

	bool f(const VmbErrorType&, const QString& = ""); // check vmb error and print
	void g(const VmbErrorType&, const QString& = ""); // check vmb error and throw

	//print
	void print(const QString&);
	void print(const QStringList&);
	void print(const QString&, const VmbInt64_t&);
	void print(const QString&, const std::string&);
	void print(const QString&, const double&);
	void print(const QString&, const bool&);
	void print(const char*);
	void print(const char*, const VmbInt64_t&);
	void print(const char*, const QString&);
	void print(const char*, const seconds&);


	QString progressBar(QTimer*, int width=40);
	QString progressBar(int, int width=40);

protected:
	QString formatTime(const int&);
	QString curDateTime();

private:
	int getTerminalWidth();

};
