#!/bin/bash

#scans class-B subnet 169.254.i.j
#watch CPU usage and adapt max_jobs / timeout / step_size vars to ur system
############################### Alternatives ###############################
## faster alternative:
# 	sudo arp-scan --interface=enp0s31f6 --localnet
###############################

step_size=12
max_jobs=100 # Maximum number of concurrent pings
for i in {0..255}; do
	if [ $((i % step_size)) == 0 ]; then
		echo ""
		echo "169.254.$i-$((i+step_size))"
		sleep 1
	fi
	echo -n "."

	for j in {0..255}; do
		if [[ "$i" == 255 && "$j" == 255 ]]; then
			break #ignore broadcast
		fi

		ip="169.254.$i.$j"
		(
			if ping -c2 -W2 "$ip" &> /dev/null; then
				echo -e "\n$ip <<<<<<<<<<<<<<<<<< !!\n"
			fi
		) &

		# Wait for jobs to finish if max_jobs limit is reached
		if (( $(jobs -r | wc -l) >= max_jobs )); then
			wait -n
		fi
	done
done

wait # Wait for all REMAINING

# timeout=1 # Timeout for each ping in seconds
			# if timeout "$timeout"s ping -c1 -i0.5 "$ip" &> /dev/null; then #discard both
			# if timeout "$timeout"s ping -c1 -i0.5 "$ip" > /dev/null; then #discard normal output
			# if timeout "$timeout"s ping -c1 -i0.5 "$ip" 2> /dev/null; then #discard err only
		# (ping "${ip}" -c 1 -W 1  &> /dev/null && echo -e "\n${ip} <<<<<<<<<<<<<<<<<< !!\n" &) ;



