#pragma once

/* most common includes + type definitions */

#include <vector>
#include <memory> //shared_ptr

#include <QObject>
#include <QString>
#include <QDebug>

#include <VmbCPP/Camera.h>

using VmbCPP::CameraPtr;
using VmbCPP::FramePtr;
using VmbCPP::FeaturePtr;
using VmbCPP::FramePtrVector;
using VmbCPP::UpdateTriggerType;

#include <chrono>
using std::chrono::minutes;
using std::chrono::seconds;
using std::chrono::duration_cast;
using namespace std::chrono_literals;

class Cam; // != Camera, which is the vimba object!
using CamPtr = std::shared_ptr<Cam>;
using CamPtrVector = std::vector<CamPtr>;

class Record;
using RecordPtr = std::shared_ptr<Record>;
